<template>
  <gl-form-group
    label="Filter"
    label-for="filter-input"
    :invalid-feedback="parseError"
    :state="state"
  >
    <client-only>
      <gl-search-box-by-type id="filter-input" :value="query" :state="state" @input="onInput" />
    </client-only>
    <template #description>
      <gl-sprintf :message="$options.description">
        <template #link="{ content }">
          <gl-link href="https://tools.ietf.org/html/rfc7644#section-3.4.2.2" target="_blank">{{
            content
          }}</gl-link>
        </template>
      </gl-sprintf>
      <scim-filter-help @query="$emit('input', $event)" />
    </template>
  </gl-form-group>
</template>

<script>
import GlFormGroup from '@gitlab/ui/src/components/base/form/form_group/form_group.vue';
import GlSprintf from '@gitlab/ui/src/components/utilities/sprintf/sprintf.vue';
import GlLink from '@gitlab/ui/src/components/base/link/link.vue';
import GlSearchBoxByType from '@gitlab/ui/src/components/base/search_box_by_type/search_box_by_type.vue';
import debounce from 'lodash/debounce';
import ScimFilterHelp from './scim_filter_help.vue';
import { getScim2Filter } from '~/lib/scim2';

export default {
  name: 'ScimFilter',
  components: {
    GlFormGroup,
    GlLink,
    GlSearchBoxByType,
    GlSprintf,
    ScimFilterHelp,
  },
  model: {
    prop: 'query',
    event: 'input',
  },
  props: {
    query: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      parseError: '',
    };
  },
  computed: {
    state() {
      return this.parseError ? false : null;
    },
  },
  watch: {
    query: {
      handler: 'updateFilter',
      immediate: true,
    },
  },
  methods: {
    onInput(query) {
      this.$emit('input', query);
    },
    updateFilter: debounce(function updateFilter(query) {
      this.parseError = '';
      const { filterFn, parseError } = getScim2Filter(query);

      if (parseError) {
        this.parseError = parseError;
        return;
      }

      this.$emit('filter', filterFn);
    }, 200),
  },
  description: 'Use the %{linkStart}SCIM 2.0 filter language%{linkEnd} to filter findings.',
};
</script>
